// Generated by CoffeeScript 1.10.0
var _, colors, fn, log, method, prettyError, prettyJSON, theme;

colors = require('colors/safe');

theme = {
  debug: 'blue',
  info: 'white',
  warn: 'yellow',
  error: 'red',
  bebop: 'black',
  modified: 'cyan',
  compiled: 'blue'
};

colors.setTheme(theme);

prettyJSON = function(obj) {
  return JSON.stringify(obj, null, 2);
};

prettyError = function(err) {
  var msg, std;
  msg = err.toString() + '\n';
  std = [];
  if (err.stdout != null) {
    std.push(err.stdout);
  }
  if (err.stderr != null) {
    std.push(err.stderr);
  }
  if (std.length > 0) {
    msg += std.join('\n');
  } else {
    msg += err.stack;
  }
  return msg;
};

log = function() {
  if (root.console == null) {
    return console.log.apply(console, arguments);
  }
};

fn = function(method) {
  var prefix;
  prefix = colors[method](method + ' ');
  return log[method] = function(msg, extra) {
    var err;
    if (typeof msg === 'string') {
      msg = prefix + msg;
    } else {
      msg = prefix + '\n' + pretty(msg);
    }
    err = null;
    if (msg instanceof Error) {
      msg = prettyError(msg);
    }
    if (extra instanceof Error) {
      extra = prettyError(extra);
    } else {
      extra = prettyJSON(extra);
    }
    if (extra != null) {
      msg = msg + '\n' + extra;
    }
    if (err != null) {
      return console.error(msg);
    } else {
      return console.log(msg);
    }
  };
};
for (method in theme) {
  _ = theme[method];
  fn(method);
}

module.exports = log;
